import { ComputedRef, ShallowRef, Ref } from 'vue';
import { GanttRowNode, TimePoint, TimeLine, TimePointNode, VisibleTimeLine } from '../../../../types';
import { default as dayjs } from 'dayjs';
export declare const createTimePointNodes: (timeLine: TimeLine) => {
    date: dayjs.Dayjs;
    id: string;
    data: TimePoint;
    icon: string | undefined;
    useTimePointComp: boolean | undefined;
    translateX: number;
    compParams: any;
}[] | undefined;
export declare const useTimePoint: ({ timePointSize, perHourSpacing, rowNodeMap, visibleTimeLineMap }: {
    timePointSize: ComputedRef<number>;
    perHourSpacing: Ref<number>;
    rowNodeMap: Ref<Map<string, GanttRowNode>, Map<string, GanttRowNode>>;
    visibleTimeLineMap: ShallowRef<Map<string, VisibleTimeLine[]>, Map<string, VisibleTimeLine[]>>;
}) => {
    onTimePointContextMenu: (e: MouseEvent, timeLine: VisibleTimeLine, timePoint: TimePointNode, rowId: string) => void;
    onTimePointMouseDown: (e: MouseEvent, timeLine: VisibleTimeLine, timePoint: TimePointNode) => void;
};
