import { default as dayjs } from 'dayjs';
import { RowData, GanttRowNode, GanttStyleOption } from '../../../types';
export interface Props {
    rowHeight: number;
    edgeSpacing: number;
    perHourSpacing: number;
    rowBuffer: number;
    ganttMinDate: dayjs.Dayjs;
    ganttMaxDate: dayjs.Dayjs | null;
    ganttViewWidth: number;
    rows: RowData[];
    rowNodeMap: Map<string, GanttRowNode>;
    visibleRowIds: string[];
    styleOption?: GanttStyleOption;
    timePointComp?: any;
    timeLineRender?: any;
    timeLineRenderParams?: Record<string, any>;
}
declare const _default: import('vue').DefineComponent<Props, {
    onResize: () => void;
    onScroll: ({ scrollTop, scrollLeft }: {
        scrollTop: number;
        scrollLeft: number;
    }) => void;
    freshTimeLines: (rowNodes: GanttRowNode[]) => void;
}, {}, {}, {}, import('vue').ComponentOptionsMixin, import('vue').ComponentOptionsMixin, {} & {
    updateMinDate: (date: dayjs.Dayjs) => any;
    updateMaxDate: (date: dayjs.Dayjs) => any;
}, string, import('vue').PublicProps, Readonly<Props> & Readonly<{
    onUpdateMinDate?: ((date: dayjs.Dayjs) => any) | undefined;
    onUpdateMaxDate?: ((date: dayjs.Dayjs) => any) | undefined;
}>, {}, {}, {}, {}, string, import('vue').ComponentProvideOptions, false, {
    ganttGridRef: import('vue').CreateComponentPublicInstanceWithMixins<Readonly<import('./ganttGrid/GanttGrid.vue').Props> & Readonly<{}>, {
        onScroll: ({ scrollTop, scrollLeft }: {
            scrollTop: number;
            scrollLeft: number;
        }) => void;
        onResize: () => void;
    }, {}, {}, {}, import('vue').ComponentOptionsMixin, import('vue').ComponentOptionsMixin, {}, import('vue').PublicProps, {}, false, {}, {}, import('vue').GlobalComponents, import('vue').GlobalDirectives, string, {}, SVGSVGElement, import('vue').ComponentProvideOptions, {
        P: {};
        B: {};
        D: {};
        C: {};
        M: {};
        Defaults: {};
    }, Readonly<import('./ganttGrid/GanttGrid.vue').Props> & Readonly<{}>, {
        onScroll: ({ scrollTop, scrollLeft }: {
            scrollTop: number;
            scrollLeft: number;
        }) => void;
        onResize: () => void;
    }, {}, {}, {}, {}> | null;
    ganttTimeLineViewRef: import('vue').CreateComponentPublicInstanceWithMixins<Readonly<import('./ganttTimeLineView/GanttTimeLineView.vue').Props> & Readonly<{
        onUpdateMinDate?: ((date: dayjs.Dayjs) => any) | undefined;
        onUpdateMaxDate?: ((date: dayjs.Dayjs) => any) | undefined;
    }>, {
        onScroll: ({ scrollTop, scrollLeft }: {
            scrollTop: number;
            scrollLeft: number;
        }) => void;
        onResize: () => void;
        freshTimeLines: (rowNodes: GanttRowNode[]) => void;
    }, {}, {}, {}, import('vue').ComponentOptionsMixin, import('vue').ComponentOptionsMixin, {} & {
        updateMinDate: (date: dayjs.Dayjs) => any;
        updateMaxDate: (date: dayjs.Dayjs) => any;
    }, import('vue').PublicProps, {}, false, {}, {}, import('vue').GlobalComponents, import('vue').GlobalDirectives, string, {}, HTMLDivElement, import('vue').ComponentProvideOptions, {
        P: {};
        B: {};
        D: {};
        C: {};
        M: {};
        Defaults: {};
    }, Readonly<import('./ganttTimeLineView/GanttTimeLineView.vue').Props> & Readonly<{
        onUpdateMinDate?: ((date: dayjs.Dayjs) => any) | undefined;
        onUpdateMaxDate?: ((date: dayjs.Dayjs) => any) | undefined;
    }>, {
        onScroll: ({ scrollTop, scrollLeft }: {
            scrollTop: number;
            scrollLeft: number;
        }) => void;
        onResize: () => void;
        freshTimeLines: (rowNodes: GanttRowNode[]) => void;
    }, {}, {}, {}, {}> | null;
}, HTMLDivElement>;
export default _default;
