import { SelectionChangedEvent, CellContextMenuEvent } from 'ag-grid-community';
import { RowData, ColDef, DefaultColDef, GanttRowNode } from '../../types';
export interface Props {
    getRowId: (rowData: RowData) => string;
    columns: ColDef[];
    rows: RowData[];
    rowNodeMap: Map<string, GanttRowNode>;
    defaultCol?: DefaultColDef;
    rowHeight: number;
    headerHeight: number;
    rowBuffer: number;
    rowSelection: 'single' | 'multiple' | 'none';
    getEmptyRows?: (count: number) => RowData[];
}
declare const _default: import('vue').DefineComponent<Props, {
    scrollTo: (options: ScrollToOptions, onWheel?: boolean) => void;
    refreshCells: (rowIds: string[], force?: boolean) => void;
    onFilterChanged: () => void;
    handleEmptyRowChanged: (target?: HTMLDivElement) => boolean;
    getFirstDisplayedRow: () => number | undefined;
    getLastDisplayedRow: () => number | undefined;
}, {}, {}, {}, import('vue').ComponentOptionsMixin, import('vue').ComponentOptionsMixin, {} & {
    viewPortChanged: (data: RowData[]) => any;
    selectionChanged: (data: SelectionChangedEvent<RowData, any>) => any;
    cellContextMenu: (data: CellContextMenuEvent<RowData, any>) => any;
    triggerGanttViewScroll: (options: ScrollToOptions) => any;
    cellDoubleClicked: (rowData: RowData | undefined, columnData?: ColDef | undefined) => any;
}, string, import('vue').PublicProps, Readonly<Props> & Readonly<{
    onViewPortChanged?: ((data: RowData[]) => any) | undefined;
    onSelectionChanged?: ((data: SelectionChangedEvent<RowData, any>) => any) | undefined;
    onCellContextMenu?: ((data: CellContextMenuEvent<RowData, any>) => any) | undefined;
    onTriggerGanttViewScroll?: ((options: ScrollToOptions) => any) | undefined;
    onCellDoubleClicked?: ((rowData: RowData | undefined, columnData?: ColDef | undefined) => any) | undefined;
}>, {}, {}, {}, {}, string, import('vue').ComponentProvideOptions, false, {
    tableViewRef: HTMLDivElement;
}, HTMLDivElement>;
export default _default;
