import { Ref } from 'vue';
import { default as GanttView } from '../components/ganttView/GanttView.vue';
import { default as TableView } from '../components/tableView/TableView.vue';
import { RowData, GanttRowNode } from '../types';
export declare const useGanttRowNode: ({ ganttViewRef, tableViewRef, rows, getRowId, setExpand, setSelect, refreshCells, onViewPortChanged }: {
    ganttViewRef: Ref<InstanceType<typeof GanttView> | undefined>;
    tableViewRef: Ref<InstanceType<typeof TableView> | undefined>;
    rows: Ref<RowData[], RowData[]>;
    getRowId: (row: RowData) => string;
    setExpand: (id: string, expand: boolean) => void;
    setSelect: (id: string) => void;
    refreshCells: (ids: string[], force?: boolean) => void;
    onViewPortChanged: (data: RowData[]) => void;
}) => {
    rowNodeMap: import('vue').ShallowRef<Map<string, GanttRowNode<RowData>>, Map<string, GanttRowNode<RowData>>>;
    rowNodeIds: Ref<string[], string[]>;
    visibleRowIds: Ref<string[], string[]>;
    rowDataList: import('vue').ShallowRef<RowData[], RowData[]>;
    firstLevelRowNode: import('vue').ShallowRef<GanttRowNode<RowData>[], GanttRowNode<RowData>[]>;
    getRowNode: (id: string) => GanttRowNode<RowData> | undefined;
    getRowNodeChildren: (parentId?: string) => GanttRowNode<RowData>[];
    getRowDataList: () => RowData[];
    freshRowNodes: (rows: RowData[]) => void;
    getDisplayRows: () => RowData[] | null;
};
